freedombone-app-pleroma 52KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040104110421043104410451046104710481049105010511052105310541055105610571058105910601061106210631064106510661067106810691070107110721073107410751076107710781079108010811082108310841085108610871088108910901091109210931094109510961097109810991100110111021103110411051106110711081109111011111112111311141115111611171118111911201121112211231124112511261127112811291130113111321133113411351136113711381139114011411142114311441145114611471148114911501151115211531154115511561157115811591160116111621163116411651166116711681169117011711172117311741175117611771178117911801181118211831184118511861187118811891190119111921193119411951196119711981199120012011202120312041205120612071208120912101211121212131214121512161217121812191220122112221223122412251226122712281229123012311232123312341235123612371238123912401241124212431244124512461247124812491250125112521253125412551256125712581259126012611262126312641265126612671268126912701271127212731274127512761277127812791280128112821283128412851286128712881289129012911292129312941295129612971298129913001301130213031304130513061307130813091310131113121313131413151316131713181319132013211322132313241325132613271328132913301331133213331334133513361337133813391340134113421343134413451346134713481349135013511352135313541355135613571358135913601361136213631364136513661367136813691370137113721373137413751376137713781379138013811382138313841385138613871388138913901391
  1. #!/bin/bash
  2. # _____ _ _
  3. # | __|___ ___ ___ _| |___ _____| |_ ___ ___ ___
  4. # | __| _| -_| -_| . | . | | . | . | | -_|
  5. # |__| |_| |___|___|___|___|_|_|_|___|___|_|_|___|
  6. #
  7. # Freedom in the Cloud
  8. #
  9. # Pleroma backend application
  10. #
  11. # License
  12. # =======
  13. #
  14. # Copyright (C) 2017-2018 Bob Mottram <bob@freedombone.net>
  15. #
  16. # This program is free software: you can redistribute it and/or modify
  17. # it under the terms of the GNU Affero General Public License as published by
  18. # the Free Software Foundation, either version 3 of the License, or
  19. # (at your option) any later version.
  20. #
  21. # This program is distributed in the hope that it will be useful,
  22. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  23. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  24. # GNU Affero General Public License for more details.
  25. #
  26. # You should have received a copy of the GNU Affero General Public License
  27. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  28. VARIANTS='full full-vim social'
  29. IN_DEFAULT_INSTALL=0
  30. SHOW_ON_ABOUT=1
  31. PLEROMA_DOMAIN_NAME=
  32. PLEROMA_CODE=
  33. PLEROMA_PORT=4000
  34. PLEROMA_ONION_PORT=8011
  35. PLEROMA_REPO="https://git.pleroma.social/pleroma/pleroma.git"
  36. PLEROMA_COMMIT='45a935f0bd86501d64be7f453c08a47e46565ef9'
  37. PLEROMA_ADMIN_PASSWORD=
  38. PLEROMA_DIR=/etc/pleroma
  39. PLEROMA_SECRET_KEY=""
  40. pleroma_secret=$PLEROMA_DIR/config/dev.secret.exs
  41. PLEROMA_BACKGROUND_IMAGE_URL=
  42. PLEROMA_TITLE='Pleroma Server'
  43. # Number of months after which posts expire
  44. PLEROMA_EXPIRE_MONTHS=3
  45. pleroma_expire_posts_script=/usr/bin/pleroma-expire-posts
  46. blocking_script_file=/usr/bin/pleroma-blocking
  47. PLEROMA_SHORT_DESCRIPTION=$'Federated microblogging'
  48. PLEROMA_DESCRIPTION=$'Federated microblogging'
  49. PLEROMA_MOBILE_APP_URL='https://f-droid.org/packages/com.keylesspalace.tusky'
  50. pleroma_variables=(ONION_ONLY
  51. PLEROMA_DOMAIN_NAME
  52. PLEROMA_CODE
  53. PLEROMA_WELCOME_MESSAGE
  54. PLEROMA_BACKGROUND_IMAGE_URL
  55. DDNS_PROVIDER
  56. PLEROMA_TITLE
  57. PLEROMA_EXPIRE_MONTHS
  58. MY_EMAIL_ADDRESS
  59. MY_USERNAME)
  60. function pleroma_add_filtering {
  61. if grep -q "# begin filtering" $pleroma_secret; then
  62. return
  63. fi
  64. sed -i '/pbkdf2_rounds/a reject: []' $pleroma_secret
  65. sed -i '/pbkdf2_rounds/a federated_timeline_removal: [],' $pleroma_secret
  66. sed -i '/pbkdf2_rounds/a media_nsfw: [],' $pleroma_secret
  67. sed -i '/pbkdf2_rounds/a media_removal: [],' $pleroma_secret
  68. sed -i '/pbkdf2_rounds/a config :pleroma, :mrf_simple,' $pleroma_secret
  69. sed -i '/pbkdf2_rounds/a # begin filtering' $pleroma_secret
  70. sed -i 's|reject: | reject: |g' $pleroma_secret
  71. sed -i 's|federated_timeline_removal: | federated_timeline_removal: |g' $pleroma_secret
  72. sed -i 's|media_nsfw: | media_nsfw: |g' $pleroma_secret
  73. sed -i 's|media_removal: | media_removal: |g' $pleroma_secret
  74. create_pleroma_blocklist
  75. }
  76. function pleroma_enable_chat {
  77. if [[ "$1" == 't'* || "$1" == 'y'* || "$1" == 'T'* || "$1" == 'Y'* ]]; then
  78. sed -i 's|"chatDisabled":.*|"chatDisabled": false,|g' $PLEROMA_DIR/priv/static/static/config.json
  79. sed -i 's|:chat, enabled:.*|:chat, enabled: true|g' $PLEROMA_DIR/config/config.exs
  80. else
  81. sed -i 's|"chatDisabled":.*|"chatDisabled": true,|g' $PLEROMA_DIR/priv/static/static/config.json
  82. sed -i 's|:chat, enabled:.*|:chat, enabled: false|g' $PLEROMA_DIR/config/config.exs
  83. fi
  84. pleroma_recompile
  85. }
  86. function create_pleroma_blocklist {
  87. { echo '#!/bin/bash';
  88. echo "if [ ! -f /root/${PROJECT_NAME}-firewall-domains.cfg ]; then";
  89. echo ' exit 0';
  90. echo 'fi';
  91. echo 'if [ -f /tmp/pleroma-blocking.lock ]; then';
  92. echo ' cd /tmp';
  93. echo ' find ./pleroma*.lock -type f -mmin +5 -exec rm {} \;';
  94. echo ' if [ -f /tmp/pleroma-blocking.lock ]; then';
  95. echo ' exit 0';
  96. echo ' fi';
  97. echo 'fi';
  98. echo 'touch /tmp/pleroma-blocking.lock';
  99. echo 'objects_query="DELETE FROM objects WHERE"';
  100. echo 'objects_updated=';
  101. echo 'users_query="DELETE FROM users WHERE"';
  102. echo 'websub_server_subscriptions_query="DELETE FROM websub_server_subscriptions WHERE"';
  103. echo 'websub_server_subscriptions_updated=';
  104. echo 'filter_str=';
  105. echo 'while read blocked; do';
  106. echo " if [[ \"\$blocked\" == *\".\"* || \"\$blocked\" == *\"@\"* ]]; then";
  107. echo " if [ \${#blocked} -gt 4 ]; then";
  108. echo " if [ \$objects_updated ]; then";
  109. echo " objects_query=\"\${objects_query} or\"";
  110. echo " users_query=\"\${users_query} or\"";
  111. echo ' fi';
  112. echo " objects_query=\"\${objects_query} data->>'content' ilike '%\${blocked}%' or data->>'actor' ilike '%\${blocked}%' or data->>'to' ilike '%\${blocked}%' or data->>'id' ilike '%\${blocked}%' or data->>'external_url' ilike '%\${blocked}%'\"";
  113. echo " users_query=\"\${users_query} nickname ilike '%\${blocked}%'\"";
  114. echo ' objects_updated=1';
  115. echo " if [[ \"\$blocked\" != *\"@\"* ]]; then";
  116. echo ' # Create a filter string for the pleroma configuration';
  117. echo " if [ \"\$filter_str\" ]; then";
  118. echo " filter_str=\"\${filter_str}, \\\"\$blocked\\\"\"";
  119. echo ' else';
  120. echo " filter_str=\"\\\"\${blocked}\\\"\"";
  121. echo ' fi';
  122. echo '';
  123. echo " if ! grep -q \"127.0.0.1 \$blocked\" /etc/hosts; then";
  124. echo " echo \"127.0.0.1 \$blocked\" >> /etc/hosts";
  125. echo ' fi';
  126. echo " if [ \$websub_server_subscriptions_updated ]; then";
  127. echo " websub_server_subscriptions_query=\"\${websub_server_subscriptions_query} or\"";
  128. echo ' fi';
  129. echo " websub_server_subscriptions_query=\"\${websub_server_subscriptions_query} callback like '%\${blocked}%'\"";
  130. echo ' websub_server_subscriptions_updated=1';
  131. echo ' fi';
  132. echo ' fi';
  133. echo ' fi';
  134. echo 'done </root/freedombone-firewall-domains.cfg';
  135. echo '';
  136. echo "if [ \"\$filter_str\" ]; then";
  137. echo " if ! grep -q \" \$filter_str \" $pleroma_secret; then";
  138. echo " sed -i \"s| media_removal:.*| media_removal: [ \$filter_str ],|g\" $pleroma_secret";
  139. echo " sed -i \"s| federated_timeline_removal:.*| federated_timeline_removal: [ \$filter_str ],|g\" $pleroma_secret";
  140. echo " sed -i \"s| reject:.*| reject: [ \$filter_str ]|g\" $pleroma_secret";
  141. echo " chown -R pleroma:pleroma $PLEROMA_DIR";
  142. echo ' sudo -u pleroma mix clean';
  143. echo ' sudo -u pleroma mix deps.compile';
  144. echo ' sudo -u pleroma mix compile';
  145. echo ' systemctl restart pleroma';
  146. echo ' fi';
  147. echo 'fi';
  148. echo '';
  149. echo 'cd /etc/postgresql';
  150. echo "if [ \$objects_updated ]; then";
  151. echo " sudo -u postgres psql -d pleroma -c \"\$objects_query\"";
  152. echo " sudo -u postgres psql -d pleroma -c \"\$users_query\"";
  153. echo 'fi';
  154. echo "if [ \$websub_server_subscriptions_updated ]; then";
  155. echo " sudo -u postgres psql -d pleroma -c \"\$websub_server_subscriptions_query\"";
  156. echo 'fi';
  157. echo 'rm /tmp/pleroma-blocking.lock'; } > $blocking_script_file
  158. chmod +x $blocking_script_file
  159. if ! grep -q "$blocking_script_file" /etc/crontab; then
  160. cron_add_mins 1 "$blocking_script_file 2> /dev/null"
  161. fi
  162. }
  163. function expire_pleroma_posts {
  164. domain_name=$1
  165. expire_months=$3
  166. if [ ! "$expire_months" ]; then
  167. expire_months=3
  168. fi
  169. #expire_days=$((expire_months * 30))
  170. # files are what take up most of the backup time, so don't keep them for very long
  171. expire_days_files=7
  172. # To prevent the database size from growing endlessly this script expires posts
  173. # after a number of months
  174. if [ ! -d /etc/pleroma ]; then
  175. return
  176. fi
  177. { echo '#!/bin/bash';
  178. echo "plmonths=\"$PLEROMA_EXPIRE_MONTHS\"";
  179. echo "if [ \${#plmonths} -eq 0 ]; then";
  180. echo ' exit 1';
  181. echo 'fi';
  182. echo "if [[ \"\$plmonths\" == \"0\" ]]; then";
  183. echo ' exit 2';
  184. echo 'fi';
  185. echo "oldate=\$(date +%Y-%m-%d --date=\"\$plmonths months ago\")";
  186. echo 'cd /etc/postgresql';
  187. echo "sudo -u postgres psql -d pleroma -c \"DELETE FROM notifications WHERE inserted_at <= '\$oldate 01:01:01'\"";
  188. echo "sudo -u postgres psql -d pleroma -c \"DELETE FROM objects WHERE inserted_at <= '\$oldate 01:01:01'\""; } > $pleroma_expire_posts_script
  189. chmod +x $pleroma_expire_posts_script
  190. pleroma_expire_script=/etc/cron.daily/pleroma-expire
  191. expire_days_files_threshold=$((expire_days_files - 1))
  192. { echo '#!/bin/bash';
  193. echo 'cd /etc/postgresql';
  194. echo 'if [ -d /etc/pleroma/tempfiles ]; then';
  195. echo ' rm -rf /etc/pleroma/tempfiles';
  196. echo 'fi';
  197. echo '';
  198. echo '# make directory to temporarily store local avatars';
  199. echo 'mkdir /etc/pleroma/tempfiles';
  200. echo '';
  201. echo '# get the local avatar files';
  202. echo "avatars=\$(sudo -u postgres psql -d pleroma -c \"select avatar->>'url' from users where avatar->>'url' like '%${domain_name}%'\")";
  203. echo '';
  204. echo '# copy the avatar files to a temporary directory';
  205. echo "arr=( \$avatars )";
  206. echo "for i in \${arr[@]}; do";
  207. echo " if [[ \"\$i\" == *'/media/'* ]]; then";
  208. echo " imagefile=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}');";
  209. echo " if [ -f \$imagefile ]; then";
  210. echo " imagedir=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}' | awk -F '/' '{print \$1}')";
  211. echo " nowdate=\$(date +%s)";
  212. echo " sinceepoch=\$(date +%s -r \$imagefile)";
  213. echo " daysold=\$(((\$nowdate - \$sinceepoch) / 86400))";
  214. echo " if [ \$daysold -ge ${expire_days_files_threshold} ]; then";
  215. echo " if [ ! -d \$imagedir ]; then";
  216. echo " mkdir \$imagedir";
  217. echo ' fi';
  218. echo " cp -rp \$imagefile \$imagedir";
  219. echo ' fi';
  220. echo ' fi';
  221. echo ' fi';
  222. echo 'done';
  223. echo '';
  224. echo '# get the local banner files';
  225. echo "banners=\$(sudo -u postgres psql -d pleroma -c \"select avatar->>'banner' from users where avatar->>'url' like '%${domain_name}%'\")";
  226. echo '';
  227. echo '# copy the banner files to a temporary directory';
  228. echo "arr=( \$banners )";
  229. echo "for i in \${arr[@]}; do";
  230. echo " if [[ \"\$i\" == *'/media/'* ]]; then";
  231. echo " imagefile=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}');";
  232. echo " if [ -f \$imagefile ]; then";
  233. echo " imagedir=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}' | awk -F '/' '{print \$1}')";
  234. echo " nowdate=\$(date +%s)";
  235. echo " sinceepoch=\$(date +%s -r \$imagefile)";
  236. echo " daysold=\$(((\$nowdate - \$sinceepoch) / 86400))";
  237. echo " if [ \$daysold -ge ${expire_days_files_threshold} ]; then";
  238. echo " if [ ! -d \$imagedir ]; then";
  239. echo " mkdir \$imagedir";
  240. echo ' fi';
  241. echo " cp -rp \$imagefile \$imagedir";
  242. echo ' fi';
  243. echo ' fi';
  244. echo ' fi';
  245. echo 'done';
  246. echo '';
  247. echo '# delete old files';
  248. echo "find /etc/pleroma/uploads/* -mtime +${expire_days_files} -exec rm -rf {} +";
  249. echo '';
  250. echo '# move avatar files back to uploads';
  251. echo 'chown -R pleroma:pleroma /etc/pleroma/tempfiles';
  252. echo 'mv /etc/pleroma/tempfiles/* /etc/pleroma/uploads';
  253. echo 'rm -rf /etc/pleroma/tempfiles';
  254. echo '';
  255. echo '/usr/bin/pleroma-expire-posts 2> /dev/null'; } > $pleroma_expire_script
  256. chmod +x $pleroma_expire_script
  257. # remove any old cron job
  258. if grep -q "pleroma-expire" /etc/crontab; then
  259. sed -i "/pleroma-expire/d" /etc/crontab
  260. rm /usr/bin/pleroma-expire
  261. fi
  262. # remove old expire script
  263. if [ -f /etc/cron.weekly/clear-pleroma-database ]; then
  264. rm /etc/cron.weekly/clear-pleroma-database
  265. fi
  266. }
  267. function pleroma_recompile {
  268. # necessary after parameter changes
  269. chown -R pleroma:pleroma $PLEROMA_DIR
  270. sudo -u pleroma mix clean
  271. sudo -u pleroma mix deps.compile
  272. sudo -u pleroma mix compile
  273. if [ -f /etc/systemd/system/pleroma.service ]; then
  274. systemctl restart pleroma
  275. fi
  276. }
  277. function logging_on_pleroma {
  278. echo -n ''
  279. }
  280. function logging_off_pleroma {
  281. echo -n ''
  282. }
  283. function remove_user_pleroma {
  284. remove_username="$1"
  285. cd $PLEROMA_DIR || exit 252498
  286. mix rm_user "$remove_username"
  287. "${PROJECT_NAME}-pass" -u "$remove_username" --rmapp pleroma
  288. }
  289. function add_user_pleroma {
  290. new_username="$1"
  291. new_user_password="$2"
  292. cd $PLEROMA_DIR || exit 348346
  293. mix register_user "$new_username" "$new_username" "$new_username@$HOSTNAME" $"Your bio goes here" "$new_user_password"
  294. "${PROJECT_NAME}-pass" -u "$new_username" -a pleroma -p "$new_user_password"
  295. echo '0'
  296. }
  297. function install_interactive_pleroma {
  298. if [ ! "$ONION_ONLY" ]; then
  299. ONION_ONLY='no'
  300. fi
  301. if [[ $ONION_ONLY != "no" ]]; then
  302. PLEROMA_DOMAIN_NAME='pleroma.local'
  303. else
  304. PLEROMA_DETAILS_COMPLETE=
  305. while [ ! $PLEROMA_DETAILS_COMPLETE ]
  306. do
  307. data=$(mktemp 2>/dev/null)
  308. if [[ "$DDNS_PROVIDER" == *"freedns"* ]]; then
  309. dialog --backtitle $"Freedombone Configuration" \
  310. --title $"Pleroma Configuration" \
  311. --form $"\\nPlease enter your Pleroma details. The background image URL can be left blank.\\n\\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 4 \
  312. $"Domain:" 1 1 "$(grep 'PLEROMA_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  313. $"Title:" 2 1 "$(grep "$PLEROMA_TITLE" temp.cfg | awk -F '=' '{print $2}')" 2 25 255 255 \
  314. $"Background image URL:" 3 1 "$(grep "$PLEROMA_BACKGROUND_IMAGE_URL" temp.cfg | awk -F '=' '{print $2}')" 3 25 255 255 \
  315. $"Code:" 4 1 "$(grep 'PLEROMA_CODE' temp.cfg | awk -F '=' '{print $2}')" 4 25 33 255 \
  316. 2> "$data"
  317. else
  318. dialog --backtitle $"Freedombone Configuration" \
  319. --title $"Pleroma Configuration" \
  320. --form $"\\nPlease enter your Pleroma details. The background image URL can be left blank.\\n\\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 4 \
  321. $"Domain:" 1 1 "$(grep 'PLEROMA_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  322. $"Title:" 2 1 "$(grep "$PLEROMA_TITLE" temp.cfg | awk -F '=' '{print $2}')" 2 25 255 255 \
  323. $"Background image URL:" 3 1 "$(grep "$PLEROMA_BACKGROUND_IMAGE_URL" temp.cfg | awk -F '=' '{print $2}')" 3 25 255 255 \
  324. 2> "$data"
  325. fi
  326. sel=$?
  327. case $sel in
  328. 1) rm -f "$data"
  329. exit 1;;
  330. 255) rm -f "$data"
  331. exit 1;;
  332. esac
  333. PLEROMA_DOMAIN_NAME=$(sed -n 1p < "$data")
  334. title=$(sed -n 2p < "$data")
  335. if [ ${#title} -gt 1 ]; then
  336. PLEROMA_TITLE="$title"
  337. fi
  338. img_url=$(sed -n 3p < "$data")
  339. if [ ${#img_url} -gt 1 ]; then
  340. PLEROMA_BACKGROUND_IMAGE_URL=$img_url
  341. fi
  342. if [ "$PLEROMA_DOMAIN_NAME" ]; then
  343. if [[ $PLEROMA_DOMAIN_NAME == "$HUBZILLA_DOMAIN_NAME" ]]; then
  344. PLEROMA_DOMAIN_NAME=""
  345. fi
  346. TEST_DOMAIN_NAME=$PLEROMA_DOMAIN_NAME
  347. validate_domain_name
  348. if [[ "$TEST_DOMAIN_NAME" != "$PLEROMA_DOMAIN_NAME" ]]; then
  349. PLEROMA_DOMAIN_NAME=
  350. dialog --title $"Domain name validation" --msgbox "$TEST_DOMAIN_NAME" 15 50
  351. else
  352. if [[ "$DDNS_PROVIDER" == *"freedns"* ]]; then
  353. PLEROMA_CODE=$(sed -n 4p < "$data")
  354. validate_freedns_code "$PLEROMA_CODE"
  355. if [ ! "$VALID_CODE" ]; then
  356. PLEROMA_DOMAIN_NAME=
  357. fi
  358. fi
  359. fi
  360. fi
  361. if [ $PLEROMA_DOMAIN_NAME ]; then
  362. PLEROMA_DETAILS_COMPLETE="yes"
  363. fi
  364. rm -f "$data"
  365. done
  366. # remove any invalid characters
  367. if [ ${#PLEROMA_TITLE} -gt 0 ]; then
  368. new_title=${PLEROMA_TITLE//\'/}
  369. PLEROMA_TITLE="$new_title"
  370. fi
  371. # save the results in the config file
  372. write_config_param "PLEROMA_CODE" "$PLEROMA_CODE"
  373. write_config_param "PLEROMA_TITLE" "$PLEROMA_TITLE"
  374. write_config_param "PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_BACKGROUND_IMAGE_URL"
  375. fi
  376. write_config_param "PLEROMA_DOMAIN_NAME" "$PLEROMA_DOMAIN_NAME"
  377. APP_INSTALLED=1
  378. }
  379. function change_password_pleroma {
  380. # curr_username="$1"
  381. new_user_password="$2"
  382. #${PROJECT_NAME}-pass -u "$curr_username" -a pleroma -p "$new_user_password"
  383. }
  384. function pleroma_create_database_failed {
  385. run_system_query_postgresql "ALTER USER pleroma NOSUPERUSER;"
  386. run_system_query_postgresql "ALTER USER pleroma NOCREATEDB;"
  387. }
  388. function pleroma_create_database {
  389. if [ -f "$IMAGE_PASSWORD_FILE" ]; then
  390. PLEROMA_ADMIN_PASSWORD="$(printf "%s" "$(cat "$IMAGE_PASSWORD_FILE")")"
  391. else
  392. if [ ! "$PLEROMA_ADMIN_PASSWORD" ]; then
  393. PLEROMA_ADMIN_PASSWORD="$(create_password "${MINIMUM_PASSWORD_LENGTH}")"
  394. fi
  395. fi
  396. if [ ! "$PLEROMA_ADMIN_PASSWORD" ]; then
  397. return
  398. fi
  399. systemctl restart postgresql
  400. add_postgresql_user pleroma "$PLEROMA_ADMIN_PASSWORD" encrypted
  401. run_system_query_postgresql "create database pleroma;"
  402. # temporarily allow the user to create databases
  403. run_system_query_postgresql "ALTER USER pleroma CREATEDB;"
  404. run_system_query_postgresql "ALTER USER pleroma SUPERUSER;"
  405. run_system_query_postgresql "GRANT ALL ON ALL tables IN SCHEMA public TO pleroma;"
  406. run_system_query_postgresql "GRANT ALL ON ALL sequences IN SCHEMA public TO pleroma;"
  407. run_system_query_postgresql "CREATE EXTENSION citext;"
  408. run_system_query_postgresql "set statement_timeout to 40000;"
  409. read_config_param "PLEROMA_SECRET_KEY"
  410. if [ ${#PLEROMA_SECRET_KEY} -lt 64 ]; then
  411. PLEROMA_SECRET_KEY="$(create_password 30)$(create_password 30)$(create_password 30)"
  412. if [ ${#PLEROMA_SECRET_KEY} -lt 64 ]; then
  413. pleroma_create_database_failed
  414. echo $'Pleroma secret key not created'
  415. exit 6782352
  416. fi
  417. write_config_param "PLEROMA_SECRET_KEY" "$PLEROMA_SECRET_KEY"
  418. fi
  419. if [ ! -d $PLEROMA_DIR/config ]; then
  420. echo $"Missing directory $PLEROMA_DIR/config"
  421. exit 7835393
  422. fi
  423. if [ ! -f $PLEROMA_DIR/config/dev.exs ]; then
  424. echo $"Did not find $PLEROMA_DIR/config/dev.exs"
  425. exit 78923528
  426. fi
  427. cp $PLEROMA_DIR/config/dev.exs $pleroma_secret
  428. sed -i "s|username:.*|username: \"pleroma\",|g" $pleroma_secret
  429. sed -i "s|password:.*|password: \"$PLEROMA_ADMIN_PASSWORD\",|g" $pleroma_secret
  430. sed -i "s|database:.*|database: \"pleroma\",|g" $pleroma_secret
  431. sed -i "/Pleroma.Web.Endpoint/a secret_key_base: \"$PLEROMA_SECRET_KEY\"," $pleroma_secret
  432. sed -i 's|secret_key_base: | secret_key_base: |g' $pleroma_secret
  433. sed -i "/Pleroma.Web.Endpoint/a pubsub: [name: Pleroma.Web.PubSub, adapter: Phoenix.PubSub.PG2]," $pleroma_secret
  434. sed -i 's|pubsub: | pubsub: |g' $pleroma_secret
  435. sed -i 's|watchers: []|watchers: [],|g' $pleroma_secret
  436. if [[ $ONION_ONLY == 'no' ]]; then
  437. sed -i "/watchers: []/a url: [host: \"$PLEROMA_DOMAIN_NAME\", scheme: \"https\", port: 443]" $pleroma_secret
  438. else
  439. sed -i "/watchers: []/a url: [host: \"$PLEROMA_ONION_HOSTNAME\", scheme: \"http\", port: 80]" $pleroma_secret
  440. fi
  441. sed -i 's|url: | url: |g' $pleroma_secret
  442. if ! grep -q "pbkdf2_rounds" $pleroma_secret; then
  443. sed -i '/config :logger/a config :comeonin, :pbkdf2_rounds, 1' $pleroma_secret
  444. else
  445. sed -i 's|pbkdf2_rounds.*|pbkdf2_rounds, 1|g' $pleroma_secret
  446. fi
  447. sed -i 's|import_config|# import_config|g' $pleroma_secret
  448. cd "$PLEROMA_DIR" || exit 678245245724
  449. chown -R pleroma:pleroma $PLEROMA_DIR/*
  450. if ! sudo -u pleroma mix local.rebar --force; then
  451. pleroma_create_database_failed
  452. echo $'mix local.rebar failed'
  453. exit 73528562
  454. fi
  455. sudo -u pleroma mix local.hex --force
  456. sudo -u pleroma mix deps.compile mimerl
  457. systemctl restart postgresql
  458. if ! sudo -u pleroma mix ecto.create --force; then
  459. pleroma_create_database_failed
  460. echo $'mix ecto.create failed'
  461. exit 83653582
  462. fi
  463. if ! sudo -u pleroma mix ecto.migrate --force; then
  464. pleroma_create_database_failed
  465. echo $'mix ecto.migrate failed'
  466. exit 73752573
  467. fi
  468. # revoke the ability to create databases for this user
  469. run_system_query_postgresql "ALTER USER pleroma NOSUPERUSER;"
  470. run_system_query_postgresql "ALTER USER pleroma NOCREATEDB;"
  471. }
  472. function reconfigure_pleroma {
  473. echo -n ''
  474. }
  475. function pleroma_set_background_image {
  476. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  477. data=$(mktemp 2>/dev/null)
  478. dialog --title $"Pleroma" \
  479. --backtitle $"Freedombone Control Panel" \
  480. --inputbox $'Set a background image URL' 10 60 2>"$data"
  481. sel=$?
  482. case $sel in
  483. 0)
  484. temp_background=$(<"$data")
  485. if [ ${#temp_background} -gt 0 ]; then
  486. PLEROMA_BACKGROUND_IMAGE_URL="$temp_background"
  487. write_config_param "PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_BACKGROUND_IMAGE_URL"
  488. if [[ $(pleroma_set_background_image_from_url $PLEROMA_DIR "$PLEROMA_DOMAIN_NAME" "$PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_TITLE" | tail -n 1) == "0" ]]; then
  489. pleroma_recompile
  490. dialog --title $"Set Pleroma login background" \
  491. --msgbox $"The background image has been set" 6 60
  492. fi
  493. fi
  494. ;;
  495. esac
  496. rm -f "$data"
  497. }
  498. function pleroma_set_title {
  499. data=$(mktemp 2>/dev/null)
  500. dialog --title $"Pleroma" \
  501. --backtitle $"Freedombone Control Panel" \
  502. --inputbox $'Set a title' 10 60 2>"$data"
  503. sel=$?
  504. case $sel in
  505. 0)
  506. new_title=$(<"$data")
  507. if [ ${#new_title} -gt 0 ]; then
  508. PLEROMA_TITLE="$new_title"
  509. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  510. write_config_param "PLEROMA_TITLE" "$PLEROMA_TITLE"
  511. sed -i "s|\"name\":.*|\"name\": \"${PLEROMA_TITLE}\",|g" $PLEROMA_DIR/static/config.json
  512. sed -i "s|\"name\":.*|\"name\": \"${PLEROMA_TITLE}\",|g" $PLEROMA_DIR/priv/static/static/config.json
  513. sed -i "s|name: .*|name: \"${PLEROMA_TITLE}\",|g" $PLEROMA_DIR/config/config.exs
  514. systemctl restart pleroma
  515. dialog --title $"Set Pleroma title" \
  516. --msgbox $"The title has been set" 6 60
  517. fi
  518. ;;
  519. esac
  520. rm -f "$data"
  521. }
  522. function pleroma_set_expire_months {
  523. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  524. read_config_param "PLEROMA_DOMAIN_NAME"
  525. read_config_param "PLEROMA_EXPIRE_MONTHS"
  526. data=$(mktemp 2>/dev/null)
  527. dialog --title $"Pleroma" \
  528. --backtitle $"Freedombone Control Panel" \
  529. --inputbox $'Set an expiry period for posts in months. Anything older will be deleted. Lower values help to keep the database size small and as fast as possible.' 12 60 "$PLEROMA_EXPIRE_MONTHS" 2>"$data"
  530. sel=$?
  531. case $sel in
  532. 0)
  533. new_expiry_months=$(<"$data")
  534. if [ ${#new_expiry_months} -gt 0 ]; then
  535. # should contain no spaces
  536. if [[ "$new_expiry_months" == *" "* ]]; then
  537. rm -f "$data"
  538. return
  539. fi
  540. # should be a number
  541. re='^[0-9]+$'
  542. if ! [[ $new_expiry_months =~ $re ]] ; then
  543. rm -f "$data"
  544. return
  545. fi
  546. # set the new value
  547. PLEROMA_EXPIRE_MONTHS=$new_expiry_months
  548. write_config_param "PLEROMA_EXPIRE_MONTHS" "$PLEROMA_EXPIRE_MONTHS"
  549. expire_pleroma_posts "$PLEROMA_DOMAIN_NAME" "$PLEROMA_EXPIRE_MONTHS"
  550. create_pleroma_blocklist
  551. dialog --title $"Set Pleroma post expiry period" \
  552. --msgbox $"Expiry period set to $PLEROMA_EXPIRE_MONTHS months" 6 60
  553. fi
  554. ;;
  555. esac
  556. rm -f "$data"
  557. }
  558. function pleroma_disable_registrations {
  559. dialog --title $"Disable new Pleroma user registrations" \
  560. --backtitle $"Freedombone Control Panel" \
  561. --yesno $"\\nDo you wish to disable new registrations?" 10 60
  562. sel=$?
  563. case $sel in
  564. 0) sed -i 's|registrations_open: true|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  565. sed -i 's|registrations_open: True|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  566. sed -i 's|"registrationOpen": true|"registrationOpen": false|g' $PLEROMA_DIR/priv/static/static/config.json
  567. sed -i 's|"registrationOpen": True|"registrationOpen": false|g' $PLEROMA_DIR/priv/static/static/config.json
  568. ;;
  569. 1) sed -i 's|registrations_open: false|registrations_open: true|g' $PLEROMA_DIR/config/config.exs
  570. sed -i 's|registrations_open: False|registrations_open: true|g' $PLEROMA_DIR/config/config.exs
  571. sed -i 's|"registrationOpen": false|"registrationOpen": true|g' $PLEROMA_DIR/priv/static/static/config.json
  572. sed -i 's|"registrationOpen": False|"registrationOpen": true|g' $PLEROMA_DIR/priv/static/static/config.json
  573. ;;
  574. 255) return;;
  575. esac
  576. pleroma_recompile
  577. }
  578. function pleroma_add_emoji {
  579. emoji_resolution='128x128'
  580. data=$(mktemp 2>/dev/null)
  581. dialog --backtitle $"Freedombone Control Panel" \
  582. --title $"Add Custom Emoji" \
  583. --form "\\n" 8 75 2 \
  584. $"Shortcode:" 1 1 "" 1 18 16 15 \
  585. $"ImageURL:" 2 1 "" 2 18 512 10000 \
  586. 2> "$data"
  587. sel=$?
  588. case $sel in
  589. 1) rm -f "$data"
  590. return;;
  591. 255) rm -f "$data"
  592. return;;
  593. esac
  594. shortcode=$(sed -n 1p < "$data")
  595. image_url=$(sed -n 2p < "$data")
  596. rm -f "$data"
  597. if [ ${#shortcode} -lt 2 ]; then
  598. return
  599. fi
  600. if [ ${#image_url} -lt 2 ]; then
  601. return
  602. fi
  603. if [[ "$image_url" != *'.'* ]]; then
  604. return
  605. fi
  606. if [[ "$image_url" != *'.png' && "$image_url" != *'.jpg' && "$image_url" != *'.jpeg' && "$image_url" != *'.gif' ]]; then
  607. dialog --title $"Add Custom Emoji" \
  608. --msgbox $"The image must be png/jpg/gif format" 6 60
  609. return
  610. fi
  611. if [[ "$shortcode" == *':'* || "$shortcode" == *' '* || "$shortcode" == *'.'* || "$shortcode" == *'!'* ]]; then
  612. dialog --title $"Add Custom Emoji" \
  613. --msgbox $"The shortcode contains invalid characters" 6 60
  614. return
  615. fi
  616. image_extension='png'
  617. if [[ "$image_url" == *'.jpg' || "$image_url" == *'.jpeg' ]]; then
  618. image_extension='jpg'
  619. fi
  620. if [[ "$image_url" == *'.gif' ]]; then
  621. image_extension='gif'
  622. fi
  623. if [ ! -d $PLEROMA_DIR/priv/static/emoji ]; then
  624. mkdir -p $PLEROMA_DIR/priv/static/emoji
  625. fi
  626. image_filename=$PLEROMA_DIR/priv/static/emoji/${shortcode}.${image_extension}
  627. wget "$image_url" -O "$image_filename"
  628. if [ ! -f "$image_filename" ]; then
  629. dialog --title $"Add Custom Emoji" \
  630. --msgbox $"Unable to download the image" 6 60
  631. return
  632. fi
  633. if [[ "$image_url" == *'.jpg' || "$image_url" == *'.jpeg' || "$image_url" == *'.gif' ]]; then
  634. convert "$image_filename" -resize "$emoji_resolution" "$PLEROMA_DIR/priv/static/emoji/${shortcode}.png"
  635. if [ ! -f "$PLEROMA_DIR/priv/static/emoji/${shortcode}.png" ]; then
  636. dialog --title $"Add Custom Emoji" \
  637. --msgbox $"Unable to convert empji image to png format" 6 60
  638. return
  639. fi
  640. # remove the original
  641. rm "$image_filename"
  642. image_extension='png'
  643. image_filename=$PLEROMA_DIR/priv/static/emoji/${shortcode}.${image_extension}
  644. else
  645. convert "$image_filename" -resize "$emoji_resolution" "$image_filename"
  646. fi
  647. if ! grep -q "${shortcode}," $PLEROMA_DIR/config/emoji.txt; then
  648. echo "${shortcode}, /emoji/${shortcode}.${image_extension}" >> $PLEROMA_DIR/config/emoji.txt
  649. else
  650. sed -i "s|${shortcode},.*|${shortcode}, /emoji/${shortcode}.${image_extension}|g" $PLEROMA_DIR/config/emoji.txt
  651. fi
  652. chown -R pleroma:pleroma $PLEROMA_DIR
  653. clear
  654. echo ''
  655. echo $'Recompiling Pleroma with the new emoji'
  656. systemctl stop pleroma
  657. pleroma_recompile
  658. dialog --title $"Add Custom Emoji" \
  659. --msgbox $"Custom emoji :${shortcode}: has been added" 6 70
  660. }
  661. function configure_interactive_pleroma {
  662. read_config_param PLEROMA_DOMAIN_NAME
  663. read_config_param PLEROMA_EXPIRE_MONTHS
  664. while true
  665. do
  666. chatenabled=
  667. enablechatstr=$'Enable chat system'
  668. if grep -q ':chat, enabled: true' $PLEROMA_DIR/config/config.exs; then
  669. chatenabled=1
  670. enablechatstr=$'Disable chat system'
  671. fi
  672. pleromatorstr=$'Enable routing through Tor for onion addresses'
  673. if grep -q '9050' $pleroma_secret; then
  674. pleromatorstr=$'Disable routing through Tor'
  675. fi
  676. W=(1 $"Set a background image"
  677. 2 $"Set the title"
  678. 3 $"Disable new account registrations"
  679. 4 $"Add a custom emoji"
  680. 5 $"Set post expiry period (currently $PLEROMA_EXPIRE_MONTHS months)"
  681. 6 "$enablechatstr"
  682. 7 "$pleromatorstr")
  683. # shellcheck disable=SC2068
  684. selection=$(dialog --backtitle $"Freedombone Administrator Control Panel" --title $"Pleroma" --menu $"Choose an operation, or ESC to exit:" 14 60 7 "${W[@]}" 3>&2 2>&1 1>&3)
  685. if [ ! "$selection" ]; then
  686. break
  687. fi
  688. case $selection in
  689. 1) pleroma_set_background_image;;
  690. 2) pleroma_set_title;;
  691. 3) pleroma_disable_registrations;;
  692. 4) pleroma_add_emoji;;
  693. 5) pleroma_set_expire_months;;
  694. 6) if [ $chatenabled ]; then
  695. pleroma_enable_chat false
  696. else
  697. pleroma_enable_chat true
  698. fi
  699. ;;
  700. 7) if grep -q '9050' $pleroma_secret; then
  701. pleroma_disable_tor
  702. else
  703. pleroma_enable_tor
  704. fi
  705. ;;
  706. esac
  707. done
  708. }
  709. function pleroma_disable_tor {
  710. if grep -q '9050' $pleroma_secret; then
  711. sed -i '/9050/d' $pleroma_secret
  712. sed -i 's|# config :pleroma, :http, proxy_url:|config :pleroma, :http, proxy_url:|g' $PLEROMA_DIR/config/config.exs
  713. pleroma_recompile
  714. fi
  715. }
  716. function pleroma_enable_tor {
  717. pleroma_tor_update=
  718. if ! grep -q '{:socks5, :localhost, 9050}' $pleroma_secret; then
  719. pleroma_tor_update=1
  720. fi
  721. if ! grep -q '# config :pleroma, :http, proxy_url:' $PLEROMA_DIR/config/config.exs; then
  722. pleroma_tor_update=1
  723. fi
  724. if [ ! $pleroma_tor_update ]; then
  725. return
  726. fi
  727. if ! grep -q '{:socks5, :localhost, 9050}' $pleroma_secret; then
  728. sed -i '/9050/d' $pleroma_secret
  729. sed -i '/url:/a config :pleroma, :http, proxy_url: {:socks5, :localhost, 9050}' $pleroma_secret
  730. fi
  731. if ! grep -q '# config :pleroma, :http, proxy_url:' $PLEROMA_DIR/config/config.exs; then
  732. sed -i 's|config :pleroma, :http, proxy_url:|# config :pleroma, :http, proxy_url:|g' $PLEROMA_DIR/config/config.exs
  733. fi
  734. pleroma_recompile
  735. }
  736. function upgrade_pleroma {
  737. read_config_param PLEROMA_DOMAIN_NAME
  738. read_config_param PLEROMA_EXPIRE_MONTHS
  739. pleroma_add_filtering
  740. if ! grep -q "/media/" /etc/cron.daily/pleroma-expire; then
  741. rm $pleroma_expire_posts_script
  742. fi
  743. if [ ! -f $pleroma_expire_posts_script ]; then
  744. expire_pleroma_posts "$PLEROMA_DOMAIN_NAME" "$PLEROMA_EXPIRE_MONTHS"
  745. fi
  746. if [ ! -f $blocking_script_file ]; then
  747. create_pleroma_blocklist
  748. fi
  749. #pleroma_enable_tor
  750. CURR_PLEROMA_COMMIT=$(get_completion_param "pleroma commit")
  751. if [[ "$CURR_PLEROMA_COMMIT" == "$PLEROMA_COMMIT" ]]; then
  752. return
  753. fi
  754. pleroma_registrations=open
  755. if grep -q 'registrations_open: false' $PLEROMA_DIR/config/config.exs; then
  756. pleroma_registrations=
  757. fi
  758. pleroma_chat_enabled=1
  759. if grep -q ':chat, enabled: false' $PLEROMA_DIR/config/config.exs; then
  760. pleroma_chat_enabled=
  761. fi
  762. # make a copy of the configuration
  763. cp $PLEROMA_DIR/priv/static/static/config.json $PLEROMA_DIR/priv/static/static/config_prev.json
  764. if [ -f $PLEROMA_DIR/config/emoji.txt ]; then
  765. cp $PLEROMA_DIR/config/emoji.txt $PLEROMA_DIR/config/emoji_prev.txt
  766. fi
  767. apt-get -yq update
  768. apt-get -yq install --only-upgrade esl-erlang
  769. apt-get -yq install --only-upgrade elixir erlang-xmerl erlang-dev erlang-parsetools
  770. function_check set_repo_commit
  771. set_repo_commit $PLEROMA_DIR "pleroma commit" "$PLEROMA_COMMIT" $PLEROMA_REPO
  772. chown -R pleroma:pleroma $PLEROMA_DIR
  773. # restore the configuration
  774. cp $PLEROMA_DIR/priv/static/static/config_prev.json $PLEROMA_DIR/priv/static/static/config.json
  775. chown pleroma:pleroma $PLEROMA_DIR/priv/static/static/config.json
  776. if [ -f $PLEROMA_DIR/config/emoji_prev.txt ]; then
  777. cp $PLEROMA_DIR/config/emoji_prev.txt $PLEROMA_DIR/config/emoji.txt
  778. chown pleroma:pleroma $PLEROMA_DIR/config/emoji.txt
  779. rm cp $PLEROMA_DIR/config/emoji_prev.txt
  780. fi
  781. sudo -u pleroma mix deps.get
  782. if [ ! $pleroma_registrations ]; then
  783. sed -i 's|registrations_open: true|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  784. sed -i 's|registrations_open: True|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  785. fi
  786. if [ ! $pleroma_chat_enabled ]; then
  787. sed -i 's|config :pleroma, :chat.*|config :pleroma, :chat, enabled: false|g' $PLEROMA_DIR/config/config.exs
  788. else
  789. sed -i 's|config :pleroma, :chat.*|config :pleroma, :chat, enabled: true|g' $PLEROMA_DIR/config/config.exs
  790. fi
  791. pleroma_recompile
  792. # migrate database
  793. sudo -u pleroma mix deps.clean --build mime
  794. sudo -u pleroma mix ecto.migrate
  795. pleroma_custom_logo "$PLEROMA_DIR"
  796. expire_pleroma_posts "$PLEROMA_DOMAIN_NAME" "$PLEROMA_EXPIRE_MONTHS"
  797. create_pleroma_blocklist
  798. chown -R pleroma:pleroma $PLEROMA_DIR
  799. systemctl restart pleroma
  800. }
  801. function backup_local_pleroma {
  802. PLEROMA_DOMAIN_NAME='pleroma'
  803. if grep -q "pleroma domain" "$COMPLETION_FILE"; then
  804. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  805. fi
  806. systemctl stop pleroma
  807. function_check suspend_site
  808. suspend_site "${PLEROMA_DOMAIN_NAME}"
  809. source_directory=$PLEROMA_DIR
  810. dest_directory=pleroma
  811. backup_directory_to_usb $source_directory $dest_directory
  812. USE_POSTGRESQL=1
  813. function_check backup_database_to_usb
  814. backup_database_to_usb pleroma
  815. function_check restart_site
  816. restart_site
  817. systemctl restart pleroma
  818. }
  819. function restore_local_pleroma {
  820. if ! grep -q "pleroma domain" "$COMPLETION_FILE"; then
  821. return
  822. fi
  823. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  824. if [ "$PLEROMA_DOMAIN_NAME" ]; then
  825. echo $"Restoring pleroma"
  826. temp_restore_dir=/root/temppleroma
  827. pleroma_dir=$PLEROMA_DIR
  828. systemctl stop pleroma
  829. PLEROMA_ONION_HOSTNAME=$(cat /var/lib/tor/hidden_service_pleroma/hostname)
  830. function_check pleroma_create_database
  831. pleroma_create_database
  832. USE_POSTGRESQL=1
  833. restore_database pleroma
  834. if [ -d $temp_restore_dir ]; then
  835. rm -rf $temp_restore_dir
  836. fi
  837. function_check restore_directory_from_usb
  838. restore_directory_from_usb $temp_restore_dir pleroma
  839. if [ -d $temp_restore_dir ]; then
  840. chown -R pleroma:pleroma $pleroma_dir
  841. rm -rf $temp_restore_dir
  842. fi
  843. systemctl restart pleroma
  844. echo $"Restore of pleroma complete"
  845. fi
  846. }
  847. function backup_remote_pleroma {
  848. PLEROMA_DOMAIN_NAME='pleroma'
  849. if grep -q "pleroma domain" "$COMPLETION_FILE"; then
  850. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  851. fi
  852. systemctl stop pleroma
  853. function_check suspend_site
  854. suspend_site "${PLEROMA_DOMAIN_NAME}"
  855. source_directory=$PLEROMA_DIR
  856. dest_directory=pleroma
  857. backup_directory_to_friend $source_directory $dest_directory
  858. USE_POSTGRESQL=1
  859. function_check backup_database_to_friend
  860. backup_database_to_friend pleroma
  861. function_check restart_site
  862. restart_site
  863. systemctl restart pleroma
  864. }
  865. function restore_remote_pleroma {
  866. if ! grep -q "pleroma domain" "$COMPLETION_FILE"; then
  867. return
  868. fi
  869. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  870. if [ "$PLEROMA_DOMAIN_NAME" ]; then
  871. echo $"Restoring pleroma"
  872. temp_restore_dir=/root/temppleroma
  873. pleroma_dir=$PLEROMA_DIR
  874. systemctl stop pleroma
  875. PLEROMA_ONION_HOSTNAME=$(cat /var/lib/tor/hidden_service_pleroma/hostname)
  876. function_check pleroma_create_database
  877. pleroma_create_database
  878. # shellcheck disable=SC2034
  879. USE_POSTGRESQL=1
  880. function_check restore_database_from_friend
  881. restore_database_from_friend pleroma
  882. if [ -d $temp_restore_dir ]; then
  883. rm -rf $temp_restore_dir
  884. fi
  885. function_check restore_directory_from_friend
  886. restore_directory_from_friend $temp_restore_dir pleroma
  887. if [ -d $temp_restore_dir ]; then
  888. chown -R pleroma:pleroma $pleroma_dir
  889. rm -rf $temp_restore_dir
  890. fi
  891. systemctl restart pleroma
  892. echo $"Restore of pleroma complete"
  893. fi
  894. }
  895. function remove_pleroma {
  896. if [ ${#PLEROMA_DOMAIN_NAME} -eq 0 ]; then
  897. return
  898. fi
  899. systemctl stop pleroma
  900. systemctl disable pleroma
  901. rm /etc/systemd/system/pleroma.service
  902. userdel pleroma
  903. #remove_elixir
  904. function_check remove_nodejs
  905. remove_nodejs pleroma-backend
  906. read_config_param "PLEROMA_DOMAIN_NAME"
  907. read_config_param "MY_USERNAME"
  908. echo "Removing $PLEROMA_DOMAIN_NAME"
  909. nginx_dissite "$PLEROMA_DOMAIN_NAME"
  910. remove_certs "$PLEROMA_DOMAIN_NAME"
  911. if [ -d "/var/www/$PLEROMA_DOMAIN_NAME" ]; then
  912. rm -rf "/var/www/$PLEROMA_DOMAIN_NAME"
  913. fi
  914. if [ -f "/etc/nginx/sites-available/$PLEROMA_DOMAIN_NAME" ]; then
  915. rm "/etc/nginx/sites-available/$PLEROMA_DOMAIN_NAME"
  916. fi
  917. if [ -d $PLEROMA_DIR ]; then
  918. rm -rf $PLEROMA_DIR
  919. fi
  920. function_check drop_database_postgresql
  921. drop_database_postgresql pleroma
  922. function_check remove_onion_service
  923. remove_onion_service pleroma ${PLEROMA_ONION_PORT}
  924. remove_app pleroma
  925. remove_completion_param install_pleroma
  926. sed -i '/pleroma domain/d' "$COMPLETION_FILE"
  927. sed -i '/pleroma commit/d' "$COMPLETION_FILE"
  928. sed -i "/$blocking_script_file/d" /etc/crontab
  929. if [ -f /usr/bin/pleroma-blocking ]; then
  930. rm /usr/bin/pleroma-blocking
  931. fi
  932. function_check remove_ddns_domain
  933. remove_ddns_domain "$PLEROMA_DOMAIN_NAME"
  934. }
  935. function image_install_pleroma {
  936. if [[ "$SOCIALINSTANCE" != 'pleroma' ]]; then
  937. return
  938. fi
  939. # shellcheck disable=SC2154
  940. chroot "$rootdir" apt-get -yq install wget imagemagick
  941. image_install_elixir
  942. image_install_postgresql
  943. }
  944. function install_pleroma {
  945. if [ ! $ONION_ONLY ]; then
  946. ONION_ONLY='no'
  947. fi
  948. apt-get -yq install wget imagemagick
  949. # We need elixir 1.4+ here, so the debian repo package won't do
  950. install_elixir
  951. function_check install_nodejs
  952. install_nodejs pleroma-backend
  953. install_postgresql
  954. if [ ! -d "/var/www/${PLEROMA_DOMAIN_NAME}/htdocs" ]; then
  955. mkdir -p "/var/www/${PLEROMA_DOMAIN_NAME}/htdocs"
  956. fi
  957. if [ -d $PLEROMA_DIR ]; then
  958. rm -rf $PLEROMA_DIR
  959. fi
  960. # get the repo
  961. if [ -f /repos/pleroma/index.html ]; then
  962. mv /repos/pleroma /repos/pleroma-fe
  963. fi
  964. if [ -d /repos/pleroma ]; then
  965. mkdir -p $PLEROMA_DIR
  966. cp -r -p /repos/pleroma/. $PLEROMA_DIR
  967. cd "$PLEROMA_DIR" || exit 834537453
  968. git pull
  969. else
  970. function_check git_clone
  971. git_clone $PLEROMA_REPO $PLEROMA_DIR
  972. fi
  973. if [ ! -d $PLEROMA_DIR ]; then
  974. echo $'Unable to clone pleroma backend repo'
  975. exit 783523
  976. fi
  977. # create user
  978. useradd -d $PLEROMA_DIR -s /bin/false pleroma
  979. # checkout the commit
  980. cd "$PLEROMA_DIR" || exit 62452428
  981. git checkout $PLEROMA_COMMIT -b $PLEROMA_COMMIT
  982. set_completion_param "pleroma commit" "$PLEROMA_COMMIT"
  983. chown -R pleroma:pleroma $PLEROMA_DIR
  984. # web config
  985. function_check add_ddns_domain
  986. add_ddns_domain "$PLEROMA_DOMAIN_NAME"
  987. PLEROMA_ONION_HOSTNAME=$(add_onion_service pleroma 80 ${PLEROMA_ONION_PORT})
  988. pleroma_nginx_site=/etc/nginx/sites-available/$PLEROMA_DOMAIN_NAME
  989. if [[ $ONION_ONLY == "no" ]]; then
  990. function_check nginx_http_redirect
  991. nginx_http_redirect "$PLEROMA_DOMAIN_NAME" "index index.html"
  992. { echo '';
  993. echo 'proxy_cache_path /tmp/pleroma-media-cache levels=1:2 keys_zone=pleroma_media_cache:10m max_size=100m inactive=80m use_temp_path=off;';
  994. echo '';
  995. echo 'server {';
  996. echo ' listen 443 ssl http2;';
  997. echo ' #listen [::]:443 ssl http2;';
  998. echo " server_name $PLEROMA_DOMAIN_NAME;";
  999. echo '';
  1000. echo ' # Security'; } >> "$pleroma_nginx_site"
  1001. function_check nginx_ssl
  1002. nginx_ssl "$PLEROMA_DOMAIN_NAME"
  1003. function_check nginx_security_options
  1004. nginx_security_options "$PLEROMA_DOMAIN_NAME"
  1005. { echo ' add_header Strict-Transport-Security max-age=0;';
  1006. echo '';
  1007. echo ' # Logs';
  1008. echo ' access_log /dev/null;';
  1009. echo ' error_log /dev/null;';
  1010. echo '';
  1011. echo " root $PLEROMA_DIR;";
  1012. echo '';
  1013. echo ' index index.html;';
  1014. echo '';
  1015. echo ' gzip_vary on;';
  1016. echo ' gzip_proxied any;';
  1017. echo ' gzip_comp_level 6;';
  1018. echo ' gzip_buffers 16 8k;';
  1019. echo ' gzip_http_version 1.1;';
  1020. echo ' gzip_types text/plain text/css application/json application/javascript text/xml application/xml application/xml+rss text/javascript application/activity+json application/atom+xml;';
  1021. echo '';
  1022. echo ' location / {';
  1023. echo ' client_max_body_size 15m;';
  1024. echo ' client_body_buffer_size 15m;';
  1025. echo '';
  1026. echo ' limit_conn conn_limit_per_ip 50;';
  1027. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1028. echo '';
  1029. echo " add_header 'Access-Control-Allow-Origin' '*' always;";
  1030. echo " add_header 'Access-Control-Allow-Methods' 'POST, GET, OPTIONS' always;";
  1031. echo " add_header 'Access-Control-Allow-Headers' 'Authorization, Content-Type' always;";
  1032. echo " if (\$request_method = OPTIONS) {";
  1033. echo ' return 204;';
  1034. echo ' }';
  1035. echo '';
  1036. echo ' proxy_http_version 1.1;';
  1037. echo " proxy_set_header Upgrade \$http_upgrade;";
  1038. echo ' proxy_set_header Connection "upgrade";';
  1039. echo " proxy_set_header Host \$http_host;";
  1040. echo '';
  1041. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1042. echo ' }';
  1043. echo '';
  1044. echo ' location /proxy {';
  1045. echo ' client_max_body_size 15m;';
  1046. echo ' client_body_buffer_size 15m;';
  1047. echo '';
  1048. echo ' limit_conn conn_limit_per_ip 50;';
  1049. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1050. echo '';
  1051. echo ' proxy_cache pleroma_media_cache;';
  1052. echo ' proxy_cache_lock on;';
  1053. echo ' proxy_ignore_client_abort on;';
  1054. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1055. echo ' }';
  1056. echo ' # include snippets/well-known.conf;';
  1057. echo '}'; } >> "$pleroma_nginx_site"
  1058. else
  1059. echo 'proxy_cache_path /tmp/pleroma-media-cache levels=1:2 keys_zone=pleroma_media_cache:10m max_size=100m inactive=80m use_temp_path=off;' > "$pleroma_nginx_site"
  1060. echo '' >> "$pleroma_nginx_site"
  1061. fi
  1062. { echo 'server {';
  1063. echo " listen 127.0.0.1:$PLEROMA_ONION_PORT default_server;";
  1064. echo " server_name $PLEROMA_ONION_HOSTNAME;";
  1065. echo ''; } >> "$pleroma_nginx_site"
  1066. function_check nginx_security_options
  1067. nginx_security_options "$PLEROMA_DOMAIN_NAME"
  1068. { echo '';
  1069. echo ' # Logs';
  1070. echo ' access_log /dev/null;';
  1071. echo ' error_log /dev/null;';
  1072. echo '';
  1073. echo " root $PLEROMA_DIR;";
  1074. echo '';
  1075. echo ' index index.html;';
  1076. echo '';
  1077. echo ' gzip_vary on;';
  1078. echo ' gzip_proxied any;';
  1079. echo ' gzip_comp_level 6;';
  1080. echo ' gzip_buffers 16 8k;';
  1081. echo ' gzip_http_version 1.1;';
  1082. echo ' gzip_types text/plain text/css application/json application/javascript text/xml application/xml application/xml+rss text/javascript application/activity+json application/atom+xml;';
  1083. echo '';
  1084. echo ' location / {';
  1085. echo ' client_max_body_size 15m;';
  1086. echo ' client_body_buffer_size 15m;';
  1087. echo '';
  1088. echo ' limit_conn conn_limit_per_ip 50;';
  1089. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1090. echo '';
  1091. echo " add_header 'Access-Control-Allow-Origin' '*' always;";
  1092. echo " add_header 'Access-Control-Allow-Methods' 'POST, GET, OPTIONS' always;";
  1093. echo " add_header 'Access-Control-Allow-Headers' 'Authorization, Content-Type' always;";
  1094. echo " if (\$request_method = OPTIONS) {";
  1095. echo ' return 204;';
  1096. echo ' }';
  1097. echo '';
  1098. echo ' proxy_http_version 1.1;';
  1099. echo " proxy_set_header Upgrade \$http_upgrade;";
  1100. echo ' proxy_set_header Connection "upgrade";';
  1101. echo " proxy_set_header Host \$http_host;";
  1102. echo '';
  1103. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1104. echo ' }';
  1105. echo '';
  1106. echo ' location /proxy {';
  1107. echo ' client_max_body_size 15m;';
  1108. echo ' client_body_buffer_size 15m;';
  1109. echo '';
  1110. echo ' limit_conn conn_limit_per_ip 50;';
  1111. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1112. echo '';
  1113. echo ' proxy_cache pleroma_media_cache;';
  1114. echo ' proxy_cache_lock on;';
  1115. echo ' proxy_ignore_client_abort on;';
  1116. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1117. echo ' }';
  1118. echo ' # include snippets/well-known.conf;';
  1119. echo '}'; } >> "$pleroma_nginx_site"
  1120. # back end
  1121. cd "$PLEROMA_DIR" || exit 246824684
  1122. chown -R pleroma:pleroma "$PLEROMA_DIR/"*
  1123. if ! sudo -u pleroma mix local.hex --force; then
  1124. echo $'mix local.hex failed'
  1125. exit 1745673
  1126. fi
  1127. mix local.hex --force
  1128. if ! sudo -u pleroma mix deps.get --force; then
  1129. echo $'mix deps.get failed'
  1130. exit 7325733
  1131. fi
  1132. function_check pleroma_create_database
  1133. pleroma_create_database
  1134. "${PROJECT_NAME}-pass" -u "$MY_USERNAME" -a pleroma -p "$PLEROMA_ADMIN_PASSWORD"
  1135. # NOTE: we don't need to install the frontend separately,
  1136. # since the backend contains a precompiled version of it
  1137. install_gnusocial_default_background "pleroma" "$PLEROMA_DOMAIN_NAME"
  1138. if [ ! -f "$PLEROMA_DIR/priv/static/static/config.json" ]; then
  1139. echo $"$PLEROMA_DIR/priv/static/static/config.json file missing"
  1140. exit 323689
  1141. fi
  1142. sed -i 's|"theme":.*|"theme": "base16-summerfruit-dark.css",|g' "$PLEROMA_DIR/priv/static/static/config.json"
  1143. if [ "$PLEROMA_BACKGROUND_IMAGE_URL" ]; then
  1144. pleroma_set_background_image_from_url $PLEROMA_DIR/priv/static "$PLEROMA_DOMAIN_NAME" "$PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_TITLE"
  1145. fi
  1146. # Get certificate
  1147. function_check create_site_certificate
  1148. create_site_certificate "$PLEROMA_DOMAIN_NAME" 'yes'
  1149. function_check nginx_ensite
  1150. nginx_ensite "$PLEROMA_DOMAIN_NAME"
  1151. systemctl restart postgresql
  1152. systemctl restart nginx
  1153. set_completion_param "pleroma domain" "$PLEROMA_DOMAIN_NAME"
  1154. # We need to set up the url option again because it somehow gets
  1155. # lost during mix compile
  1156. if ! grep -q 'watchers: \[],' $pleroma_secret; then
  1157. sed -i 's|watchers: \[\]|watchers: \[\],|g' $pleroma_secret
  1158. fi
  1159. if ! grep -q 'url:' $pleroma_secret; then
  1160. if [[ $ONION_ONLY == 'no' ]]; then
  1161. sed -i "/watchers: /a url: [host: \"$PLEROMA_DOMAIN_NAME\", scheme: \"https\", port: 443]" $pleroma_secret
  1162. else
  1163. sed -i "/watchers: /a url: [host: \"$PLEROMA_ONION_HOSTNAME\", scheme: \"http\", port: 80]" $pleroma_secret
  1164. fi
  1165. fi
  1166. create_pleroma_blocklist
  1167. # daemon
  1168. { echo '[Unit]';
  1169. echo 'Description=Pleroma social network';
  1170. echo 'After=network.target postgresql.service';
  1171. echo '';
  1172. echo '[Service]';
  1173. echo 'User=pleroma';
  1174. echo "WorkingDirectory=$PLEROMA_DIR";
  1175. echo "Environment=\"HOME=$PLEROMA_DIR\"";
  1176. echo 'ExecStart=/usr/local/bin/mix phx.server';
  1177. echo "ExecReload=/bin/kill \$MAINPID";
  1178. echo 'KillMode=process';
  1179. echo 'Restart=on-failure';
  1180. echo '';
  1181. echo '[Install]';
  1182. echo 'WantedBy=multi-user.target';
  1183. echo 'Alias=pleroma.service'; } > /etc/systemd/system/pleroma.service
  1184. # avoid mixed content warnings
  1185. sed -i '/config :pleroma, :media_proxy/!b;n;c####enabled: true,' $PLEROMA_DIR/config/config.exs
  1186. sed -i 's|####enabled| enabled|g' $PLEROMA_DIR/config/config.exs
  1187. sed -i 's|redirect_on_failure:.*|redirect_on_failure: false|g' $PLEROMA_DIR/config/config.exs
  1188. sed -i 's|:chat, enabled:.*|:chat, enabled: false|g' $PLEROMA_DIR/config/config.exs
  1189. # onion routing
  1190. sed -i '/url:/a config :pleroma, :http, proxy_url: {:socks5, :localhost, 9050}' $pleroma_secret
  1191. sed -i 's|config :pleroma, :http, proxy_url:|# config :pleroma, :http, proxy_url:|g' $PLEROMA_DIR/config/config.exs
  1192. # set registrations open initially
  1193. sed -i 's|registrations_open:.*|registrations_open: true,|g' $PLEROMA_DIR/config/config.exs
  1194. sed -i 's|"registrationOpen":.*|"registrationOpen": true,|g' $PLEROMA_DIR/priv/static/static/config.json
  1195. if ! grep -q "media_proxy" $PLEROMA_DIR/priv/static/static/config.json; then
  1196. sed -i '/"name":/a "media_proxy": true,' $PLEROMA_DIR/priv/static/static/config.json
  1197. sed -i 's|"media_proxy"| "media_proxy"|g' $PLEROMA_DIR/priv/static/static/config.json
  1198. else
  1199. sed -i 's|"media_proxy".*|"media_proxy": false,|g' $PLEROMA_DIR/priv/static/static/config.json
  1200. fi
  1201. sed -i 's|"chatDisabled":.*|"chatDisabled": true,|g' $PLEROMA_DIR/priv/static/static/config.json
  1202. pleroma_add_filtering
  1203. systemctl daemon-reload
  1204. systemctl enable pleroma
  1205. systemctl start pleroma
  1206. cd $PLEROMA_DIR || exit 1935638
  1207. sudo -u pleroma mix register_user "$MY_USERNAME" "$MY_USERNAME" "$MY_EMAIL_ADDRESS" $"Your bio goes here" "$PLEROMA_ADMIN_PASSWORD"
  1208. sudo -u pleroma mix set_moderator "$MY_USERNAME" true
  1209. APP_INSTALLED=1
  1210. }
  1211. # NOTE: deliberately there is no "exit 0"